//= =,   4, 2005 .  =1
//Makefile: Name=rh2, MCU=atmega8, Level=2, Debug=VMLab =2
//: SUT0=CKSEL3=CKSEL2=CKSEL1="0" (. 1 ) =3
#include <avr/io.h>           // - =4
#define PLUS  PB2     //    SB1 "+" =5
#define MINUS PB6     //    SB2 "-" =6
#define VYBOR PB7 //    SB3 "" =7
unsigned char p=1, v=0;  //   HL =8
//---------   50 ---------- =9
void pause (void)  //     =10
{ unsigned int delay=0; //    =11
  while (delay++ < 7000);      //  7000  =12
  return;               //    =13
}               //   "pause" =14
//----------   ----------- =15
unsigned char key (unsigned char kn)   //"kn" -  =16
{ if (bit_is_clear(PINB, kn)) //  ,  =17
  { pause();   // 50    "" =18
    if (bit_is_clear(PINB, kn))   //  =19
    { return (0);     // "0"    =20
    }             //  "if"   19 =21
  }               //  "if"   17 =22
  return (1);     // "1"    =23
}                 //   "key" =24
//--------   --------- =25
void ind (unsigned char number) //"number"-  =26
{ if (number == 1) PORTD=0xFE;   //  HL1 =27
  if (number == 2) PORTD=0xFC;     // HL1, HL2 =28
  if (number == 3) PORTD=0xF8;      // HL1-HL3 =29
  if (number == 4) PORTD=0xF0;      // HL1-HL4 =30
  if (number == 5) PORTD=0xE0;      // HL1-HL5 =31
  if (number == 6) PORTD=0xC0;      // HL1-HL6 =32
  if (number == 7) PORTD=0x80;      // HL1-HL7 =33
  if (number == 8) PORTD=0x00;      // HL1-HL8 =34
  return;               //    =35
}                 //   "ind" =36
//=============== =================== =37
int main(void)             //   =38
{ unsigned char a;     // ,  =39
  PORTB=0xFF;    //  B -    =40
  PORTC=PORTD=DDRC=DDRD=0xFF; //PC  PD-  .1 =41
  ind (1);           //  HL1   =42
  PORTC = 0xFE;   //  HL9 () =43
  while (1)    //    44-60 =44
  { if ((key(PLUS)) == 0) //  "+" =45
    { if (++p > 8) p=8;    // ,   =46
      ind (p);    //     =47
      for (a=0; a < 5; a++) pause(); //  250  =48
    }             //  "if"   46 =49
    if ((key(MINUS)) == 0) //  ."-" =50
    { if (--p < 1) p=1;     // ,   =51
      ind (p);    //     =52
      for (a=0; a < 5; a++) pause(); //  250  =53
    }             //  "if"   50 =54
    if ((key(VYBOR)) == 0) //  . =55
    { if (++v > 5) v=0;   // ,    =56
      PORTC = ~(1 << v);          // HL9-HL14 =57
      for (a=0; a < 5; a++) pause(); //  250  =58
    }  	          //  "if"   55 =59
  }            //  "while"   44 =60
}             //WinAVR-20050214,   446  =61
